﻿using System;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.SilverlightCore;

namespace ThinkGeo.MapSuite.SilverlightEdition
{
    public class CustomSimpleMarkerOverlay : SimpleMarkerOverlay
    {
        public CustomSimpleMarkerOverlay()
            : this(Guid.NewGuid().ToString())
        { }

        public CustomSimpleMarkerOverlay(string id)
            : base(id)
        {
        }

        public double MaximumScale { get; set; }

        public double MinimumScale { get; set; }

        public double MaximumSize { get; set; }

        public double MinimumSize { get; set; }
        

        protected override Collection<Marker> GetDrawingMarkersCore(RectangleShape worldExtent)
        {
            var markers = base.GetDrawingMarkersCore(worldExtent);
            var currentScale = MapInfo.CurrentScale;
            if (currentScale > MaximumScale) { currentScale = MaximumScale; }
            else if (currentScale < MinimumScale) { currentScale = MinimumScale; }

            float markerSize = (float)(MaximumSize - ((currentScale - MinimumScale) * (MaximumSize - MinimumSize)) / (MaximumScale - MinimumScale));

            foreach (var marker in markers)
            {
                marker.Width = markerSize;
                marker.Height = markerSize;
                marker.ImageHeight = markerSize;
                marker.ImageWidth = markerSize;
                marker.ImageOffsetX = -marker.Width / 2;
            }

            return markers;
        }
    }
}
