﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using ThinkGeo.MapSuite.SilverlightCore;
using ThinkGeo.MapSuite.SilverlightEdition;

namespace InMemoryMarkerOverlaySample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += MainPage_Loaded;
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            WorldMapKitWmsSilverlightOverlay baseOverlay = new WorldMapKitWmsSilverlightOverlay();
            Map1.Overlays.Add(baseOverlay);

            CustomSimpleMarkerOverlay markerOverlay = new CustomSimpleMarkerOverlay("Markers")
            {
                MaximumScale = 100000000,
                MinimumScale = 1000000,
                MaximumSize = 80,
                MinimumSize = 10
            };
            var greenMarker = new Marker(-94.558, 39.078)
            {
                ImageSource = new BitmapImage(new Uri("resource/marker_green_shadow.png", UriKind.RelativeOrAbsolute)),
                Popup = { Content = "Green Marker" }
            };
            markerOverlay.Markers.Add(greenMarker);
            var redMarker = new Marker(-84.558, 30.078)
            {
                ImageSource = new BitmapImage(new Uri("resource/marker_red_shadow.png", UriKind.RelativeOrAbsolute)),
                Popup = { Content = "Red Marker" }
            };
            markerOverlay.Markers.Add(redMarker);

            Map1.Overlays.Add("SimpleMarkerOverlay", markerOverlay);
            Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
        }
    }
}
